var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.deployWeb=exports.runWebDevServer=exports.configureWebProject=exports.runWeb=exports.buildWeb=void 0;
var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _shelljs=_interopRequireDefault(require("shelljs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _open=_interopRequireDefault(require("open"));
var _ip=_interopRequireDefault(require("ip"));
var _exec=require("../systemTools/exec");
var _common=require("../common");




























var _fileutils=require("../systemTools/fileutils");
var _pluginTools=require("../pluginTools");
var _webTools=require("../deployTools/webTools");

var _constants=require("../constants");var _require=

require('child_process'),fork=_require.fork;

var _generateWebpackConfigs=function _generateWebpackConfigs(c){
var appFolder=(0,_common.getAppFolder)(c,c.platform);
var templateFolder=(0,_common.getAppTemplateFolder)(c,c.platform);

var plugins=c.files.pluginConfig.plugins;
var modulePaths=[];
var moduleAliasesString='';

for(var key in plugins){
var plugin=(0,_pluginTools.getMergedPlugin)(c,key,plugins);
if(!plugin){

}else if(plugin.webpack){
if(plugin.webpack.modulePaths){
if(plugin.webpack.modulePaths===true){
modulePaths.push("node_modules/"+key);
}else{
modulePaths=modulePaths.concat(plugin.webpack.modulePaths);
}
}
if(plugin.webpack.moduleAliases){
if(plugin.webpack.moduleAliases===true){
moduleAliasesString+="'"+key+"': {\n                  projectPath: 'node_modules/"+
key+"'\n                },";

}else{
for(var aKey in plugin.webpack.moduleAliases){
if(typeof plugin.webpack.moduleAliases[aKey]==='string'){
moduleAliasesString+="'"+aKey+"': '"+plugin.webpack.moduleAliases[aKey]+"',";
}else{
moduleAliasesString+="'"+aKey+"': {\n                        projectPath: '"+
plugin.webpack.moduleAliases[aKey].projectPath+"'\n                      },";

}
}
}
}
}
}

var modulePathsString=modulePaths.length?"'"+modulePaths.join("','")+"'":'';

var env=(0,_common.getConfigProp)(c,c.platform,'environment');

(0,_fileutils.copyFileSync)(
_path.default.join(templateFolder,'_privateConfig',env==='production'?'webpack.config.js':'webpack.config.dev.js'),
_path.default.join(appFolder,'webpack.config.js'));


var extendJs="\nmodule.exports = {\n  modulePaths: ["+

modulePathsString+"],\n  moduleAliases: {\n    "+

moduleAliasesString+"\n  }\n}";



_fs.default.writeFileSync(_path.default.join(appFolder,'webpack.extend.js'),extendJs);
};

var buildWeb=function buildWeb(c,platform){return new Promise(function(resolve,reject){var _c$program=
c.program,debug=_c$program.debug,debugIp=_c$program.debugIp;
(0,_common.logTask)("buildWeb:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);

var debugVariables='';

if(debug){
(0,_common.logInfo)("Starting a remote debugger build with ip "+(debugIp||_ip.default.address())+". If this IP is not correct, you can always override it with --debugIp");
debugVariables+="DEBUG=true DEBUG_IP="+(debugIp||_ip.default.address());
}

_generateWebpackConfigs(c);

var wbp=(0,_common.resolveNodeModulePath)(c,'webpack/bin/webpack.js');

(0,_exec.execShellAsync)("npx cross-env NODE_ENV=production "+debugVariables+" node "+wbp+" -p --config ./platformBuilds/"+c.appId+"_"+platform+"/webpack.config.js").
then(function(){
(0,_common.logSuccess)("Your Build is located in "+_chalk.default.white(_path.default.join(appFolder,'public'))+" .");
resolve();
}).
catch(function(e){return reject(e);});
});};exports.buildWeb=buildWeb;

var configureWebProject=function configureWebProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureWebOSProject:"+platform);

if(!(0,_common.isPlatformActive)(c,platform,resolve))return;



(0,_common.copyBuildsFolder)(c,platform).
then(function(){return configureProject(c,platform);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.configureWebProject=configureWebProject;

var configureProject=function configureProject(c,platform,appFolderName){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureProject:"+platform);

resolve();
});};

var runWeb=function runWeb(c,platform,port){return new Promise(function(resolve,reject){
(0,_common.logTask)("runWeb:"+platform+":"+port);

(0,_common.checkPortInUse)(c,platform,port).
then(function(isPortActive){
if(!isPortActive){
(0,_common.logInfo)("Looks like your "+
_chalk.default.white(platform)+" devServer at port "+_chalk.default.white(
port)+" is not running. Starting it up for you...");


_runWebBrowser(c,platform,port,500).
then(function(){return runWebDevServer(c,platform,port);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}else{
(0,_common.logInfo)("Looks like your "+
_chalk.default.white(platform)+" devServer at port "+_chalk.default.white(
port)+" is already running. ReNativeWill use it!");


_runWebBrowser(c,platform,port).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}
}).
catch(function(e){return reject(e);});
});};exports.runWeb=runWeb;

var _runWebBrowser=function _runWebBrowser(c,platform,port){var delay=arguments.length>3&&arguments[3]!==undefined?arguments[3]:0;return new Promise(function(resolve,reject){






(0,_open.default)("http://0.0.0.0:"+port);
resolve();
});};

var runWebDevServer=function runWebDevServer(c,platform,port){return new Promise(function(resolve,reject){
(0,_common.logTask)("runWebDevServer:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var wpConfig=_path.default.join(appFolder,'webpack.config.js');
var wpPublic=_path.default.join(appFolder,'public');

_generateWebpackConfigs(c);
var wds=(0,_common.resolveNodeModulePath)(c,'webpack-dev-server/bin/webpack-dev-server.js');

_shelljs.default.exec("node "+
wds+" -d --devtool source-map --config "+wpConfig+"  --inline --hot --colors --content-base "+wpPublic+" --history-api-fallback --port "+port);

resolve();
});};exports.runWebDevServer=runWebDevServer;

var deployWeb=function deployWeb(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("deployWeb:"+platform);
(0,_webTools.selectWebToolAndDeploy)(c,platform).then(resolve).catch(reject);
});};exports.deployWeb=deployWeb;